REM
REM  ThrowMsg - throw a message in a nice box to the screen
REM    Usage: ThrowMsg(MessageContent AS STRING, SleepTime AS INTEGER = 0)
REM    SleepTime is defined in ms, and is optional (use -1 to wait for a keypress)
REM

SUB ThrowMsg(MessageContent AS STRING, SleepTime AS INTEGER = 0)
  DIM MsgArray(1 TO 15) AS STRING
  DIM WorkString AS STRING = MessageContent
  DIM AS INTEGER MsgLines = 0, MsgWidth, x, y, StartingLine, StartingColumn, MaxMsgWidth
  IF xSize \ 2 >= 30 THEN
      MsgWidth = xSize \ 2
    ELSE
      MsgWidth = 30
  END IF
  WHILE LEN(WorkString) > 0 AND MsgLines < 15
    MsgLines += 1
    MsgArray(MsgLines) = WordWrap(WorkString, MsgWidth)
    IF LEN(MsgArray(MsgLines)) > MaxMsgWidth THEN MaxMsgWidth = LEN(MsgArray(MsgLines))
  WEND
  MsgWidth = MaxMsgWidth
  LOCATE ,,0    ' Turn off the blinking cursor
  StartingLine = (ySize - MsgLines) \ 2
  StartingColumn = (xSize - MsgWidth) \ 2 - 1
  COLOR ColorScheme.MsgWindowBorder, ColorScheme.MsgWindowBg
  LOCATE StartingLine - 1, StartingColumn : PRINT BoxChar(1); RepeatPrint(BoxChar(2), MsgWidth + 2); BoxChar(3);
  FOR x = StartingLine TO StartingLine + MsgLines - 1                                         ' Draw borders
    LOCATE x, StartingColumn: PRINT BoxChar(4); SPACE(MsgWidth + 2); BoxChar(4);              ' of the message
  NEXT x                                                                                      ' window.
  LOCATE StartingLine + MsgLines, StartingColumn : PRINT BoxChar(5); RepeatPrint(BoxChar(2), MsgWidth + 2); BoxChar(6);
  COLOR ColorScheme.MsgWindowFg, ColorScheme.MsgWindowBg             '
  y = 0                                                              '
  FOR x = StartingLine TO StartingLine + MsgLines - 1                ' Fill in the message window
    y += 1                                                           ' with the message content.
    LOCATE x, StartingColumn + 2: PRINT MsgArray(y);                 '
  NEXT x                                                             '
  IF SleepTime > 0 THEN SLEEP SleepTime, 1  ' If a sleeptime has been specified, go sleep for a while
  IF SleepTime = -1 THEN SLEEP              ' For sleeptime = -1, wait for a keypress
  RefreshScreen()                           ' Refresh the screen's content
  KeybFlush()                               ' Flush the keyboard buffer
END SUB
